die();

// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


if ($_SERVER['REQUEST_METHOD'] === 'POST') {
  // The request is using the POST method


  //var_dump($_POST);
  // Fetch Options
  //$opt_site = isset($_POST['type']) ? $_POST['type'] : $type = '';

  $post_params = array(
    "site" => isset($_POST['site']) ? $_POST['site'] : dieAfterNotif('site', 'POST'),
    "pub" => isset($_POST['pub']) ? $_POST['pub'] : dieAfterNotif('pub', 'POST'),
    "appx" => isset($_POST['appx']) ? $_POST['appx'] : dieAfterNotif('appx', 'POST'),
    "htype" => isset($_POST['htype']) ? $_POST['htype'] : dieAfterNotif('htype', 'POST'),
    "owner" => isset($_POST['owner']) ? $_POST['owner'] : dieAfterNotif('owner', 'POST'),
    "os" => isset($_POST['os']) ? $_POST['os'] : dieAfterNotif('os', 'POST'),
  );

  $accepted_values = array(
    "site" => "delta, laptop, TRG",
    "pub" => "0.0.0.0",
    "appx" => "",
    "htype" => "mutu, perso",
    "owner" => 'ddbuiq, TRG',
    "os" => "osx, win10, deb10, deb11, deb12, esxi"
  );

  // STEP 1
  // Looking for apiKey:secret in headers.
  foreach (getallheaders() as $name => $value) {
    if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
  }
  isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

  // STEP 2
  // Validate key
  $validateApiBlob = validateApiKey($uids->reqBy);

  // STEP 3
  // Validate params : Helper accepted, we're auth'd
  foreach ($post_params as $post_key => $post_param) {
    if (validateParametters($post_param, $accepted_values[$post_key]) == false) {
      // Display helper
      echo '{', PHP_EOL, '"message": "Helper: \'' . $post_param . '\' is not contained within allowed parameters : \'' . $accepted_values[$post_key] . '\' ."', PHP_EOL, '}';
      die();
    }
  }

  // STEP 4
  // Get UID to create Host
  $guid_host_resp = getUniqueID($uids->reqBy);
  $uid_host_raw = $guid_host_resp->UID;
  $uid_host_reqBy = $guid_host_resp->REQ_BY_NAME;

  //print_r($post_params);
  //print_r($validateApiBlob);
  //print_r($guid_resp);

  // STEP 5
  // Check if user don't exceed maximum allowed hosts
  $hosts->host_ownedBy = $post_params['owner'];
  $hosts->countActiveStacksForUser();
  $host_count=$hosts->host_retCount;
  //var_dump($hosts->host_retCount);

  if ($host_count >= $maximumStacksAllowedPerUser) {
    // Maximum Stack for user exceeded
    echo '{', PHP_EOL, '"error": "maximum amount of registered stacks reached for this account."', PHP_EOL, '}';
    die();
  }

  // STEP 6
  // Create Host envelop
  $hosts->host_hostingStack=0;
  $hosts->host_os=$post_params['os'];
  $hosts->host_site=$post_params['site'];
  $hosts->host_pubIP=$post_params['pub'];
  $hosts->host_appxLocation=$post_params['appx'];
  $hosts->host_hostType=$post_params['htype'];
  $hosts->host_ownedBy=$post_params['owner'];
  $hosts->host_hostUID=$uid_host_raw;
  $hosts->host_lastSeen='0000-00-00 00:00:00';

  if ($hosts->create()) {
    $message = 'Host envelop successfully created.';
    $error = false;
  } else {
    $message='Something went wrong while creating host envelop.';
    $error = true;
  }
/*
  $host_arr = array(
    "message" => $message,
    "error" => $error,
    "hosts_count" => $host_count,
    "OS" => $hosts->host_os,
    "SITE" => $hosts->host_site,
    "PUB_IP" => $hosts->host_pubIP,
    "LOC_APPX" => $hosts->host_appxLocation,
    "HOST_TYPE" => $hosts->host_hostType,
    "OWNED_BY" => $hosts->host_ownedBy,
    "HOST_UID" => $hosts->host_hostUID,
    "HOSTING_STACK" => $hosts->host_hostingStack,
    "LAST_SEEN" => $hosts->host_lastSeen
  );

  print_r(json_encode($host_arr));
*/
} else {
  echo '{', PHP_EOL, '"error": "Request method : ' . $_SERVER['REQUEST_METHOD'] . ' not allowed."', PHP_EOL, '}';
  die();
}

/*
die();


// Global ::TODO:: Variabilize it from USER/API Permission/maxs/tresholds
$maximumStacksAllowedPerUser = 1;


// Fetch Options
$type = isset($_GET['type']) ? $_GET['type'] : $type = '';

// STEP 1
// Looking for apiKey:secret in headers.
foreach (getallheaders() as $name => $value) {
  if ($name == 'x-auth-apiKey') { $uids->reqBy = $value;}
}
isset($uids->reqBy) ?  : dieAfterNotif('x-auth-apiKey', 'AUTH');

// SETP 2
// Validate key
$validateApiBlob = validateApiKey($uids->reqBy);

// STEP 3
// Get UID to generate a key
$resp = getUniqueID($uids->reqBy);
$uid_raw = $resp->UID;
$reqByName = $resp->REQ_BY_NAME;

// STEP 4
// Validate there is no weird stuff (reqByName == tmpReqByName)

$isUser = false;
$isService = false;
$identity_arr = $validateApiBlob['IDENTITY'];

if (array_key_exists('SVC_NAME', $identity_arr) && $validateApiBlob['APIKEY']['IS_USER'] == 0) {
  // Service
  $isService = true;
} elseif (array_key_exists('TRIGRAM_KEY', $identity_arr) && $validateApiBlob['APIKEY']['IS_USER'] == 1) {
  // User
  $isUser = true;
} else {
  // Not found
  echo '{', PHP_EOL, '"error": "could not find matching entries within identity array!"', PHP_EOL, '}';
  die();
}

$tmpReqByName = $validateApiBlob['REQBY'];
$__generateFakeKey = false;

//print_r($validateApiBlob);
//print_r($resp);

if ($tmpReqByName == $reqByName) {
  if ($isUser == true) {
    // is user :

    if ($validateApiBlob['APIKEY']['DESCRIPTION'] == 'generic-web-auth-token') {
      // DESC =  generic-web-auth-token --> He has no API Key (from web)

      $apiKeys->reqBy = $reqByName;
      $apiKeys->countActiveStackApiForUser();

      // Check if we're not exceding maximum allowed simultaneous keys.
      if ($apiKeys->retCount < $maximumStacksAllowedPerUser) {
        // TODO //
        // Faire la même pour les HR en ligne (dans la table HR)

        $__registeredStacks = 0;

        if ($__registeredStacks < $maximumStacksAllowedPerUser) {
          switch ($type) {
            case 'stack_key':
              $apiPrefix = 'stack_key-' . $reqByName . '-';
              $apiDesc = 'generic-stack-singleuse-token';
              break;
            
            case 'apikey':
              $apiPrefix = 'apikey-' . $reqByName . '-';
              $apiDesc = 'user-querry-apikey';
              break;
              
            default:
              $apiPrefix = 'fake_key-' . $reqByName . '-';
              $__generateFakeKey = true;
              break;
          }

        } else {
          echo '{', PHP_EOL, '"error": "maximum amount of registered stacks reached for this account."', PHP_EOL, '}';
          die();
        }
        
      } else {
        echo '{', PHP_EOL, '"error": "maximum amount of stack_api generated for this account."', PHP_EOL, '}';
        die();
      }



    } elseif ($validateApiBlob['APIKEY']['DESCRIPTION'] == 'generic-stack-singleuse-token') {
      // DESC = generic-stack-singleuse-token --> Needs a generic api : HR API & DC API
      // host --> DESC : generic-stack-hostrunner-token
      // node --> DESC : generic-stack-noderunner-token

      switch ($type) {
        case 'host':
          $apiPrefix = 'generic-stack-hr-' . $reqByName . '-';
          $apiDesc = 'generic-stack-hostrunner-token';
          break;
        
        case 'node':
          $apiPrefix = 'generic-stack-nr-' . $reqByName . '-';
          $apiDesc = 'generic-stack-noderunner-token';
          break;
        
        default:
          $apiPrefix = 'fake_key-' . $reqByName . '-';
          $__generateFakeKey = true;
          break;
      }

    } else {
      // Can be a user key ? But a user key cannot generate further API :)
      die();
    }

  } elseif ($isUser == false) {
    // Service : 
    $apiPrefix = 'svckey' . $reqByName;
  } else {
    die();
  }
} else {
  die();
}

$generatedAPIKey = $apiPrefix . $uid_raw;
$generatedAPIKeyStatus = false;

// bouchon a delete
//$__generateFakeKey = true;

if ($__generateFakeKey == false) {
  // Generate API

  $apiKeys->description = $apiDesc;
  $apiKeys->apiKey = $generatedAPIKey;
  $apiKeys->isUser = $isUser;
  $apiKeys->foreignID = $validateApiBlob['APIKEY']['FOREIGN_ID'];
  $apiKeys->isActive = $validateApiBlob['APIKEY']['IS_ACTIVE'];

  $generatedAPIKeyStatus = $apiKeys->create();

  if ($generatedAPIKeyStatus === true) {
    $message = 'apiKey successfully created!';
  } else {
    $message = 'something went terribly wrong...';    
  }
} else {
  $message = 'good job captain...!';    
}

$jsonOutput = array(
  "message" => $message,
  "timestamp" => date('Y-m-d H:i:s'),
  "api_key" => $generatedAPIKey,
  "numberOfRecords" => $apiKeys->retCount,
  "isCreated" => $generatedAPIKeyStatus,
  "isBambooz" => $__generateFakeKey
);

#  "numberOfRecords" => $apiKeys->countActiveStackApiForUser(),

print_r(json_encode($jsonOutput));


//$uids->timestamp = date('Y-m-d H:i:s');
//$uids->podUID = isset($_GET['podUID']) ? $_GET['podUID'] : dieAfterNotif("podUID");
//$uids->reqBy = isset($_GET['reqBy']) ? $_GET['reqBy'] : dieAfterNotif("reqBy");
//$lenght =  isset($_GET['len']) ? $_GET['len'] : $lenght = 12;

## Global
$apiKeys->timestamp = date('Y-m-d H:i:s');

*/